
#-------------- Rules for obvious replecement of inflection --------------#
obv_rep_dict = {
    'েরগুলির':['ের', ''],
    'েরগুলিকে':['ের', ''],
    'েরগুলি':['ের', ''],
    'গুলিকে':['ই', ''],
    'গুলির':['ই', ''],
    'গুলি':['ই', ''],
    #---------------#
    'েরগুলীর':['ের', ''],
    'েরগুলীকে':['ের', ''],
    'েরগুলী':['ের', ''],
    'গুলীকে':['ই', ''],
    'গুলীর':['ই', ''],
    'গুলী':['ই', ''],
    #--------------#
    'েরটার':['ের', ''],
    'েরটা':['ের', ''],
    'েরগুলোকে':['ের', ''],
    'েরগুলোর':['ের', ''],
    'েরগুলো':['ের', ''],
    'গুলোকে':['ই', ''],
    'গুলোর':['ই', ''],
    'গুলো':['ই', '']
}

#-------------- Rules for contradictory replacement of inflection -------------#

con_rep_dict = {
    #---------------#
    'াচ্ছেন':['ায়', ''],
    'াচ্ছে':['ায়', ''],
    'াচ্ছ':['ায়', ''],
    'াচ্ছিলাম':['ায়', ''],
    'াচ্ছিলা':['ায়', ''],
    'াচ্ছিলেন':['ায়', ''],
    'াচ্ছিলে':['ায়', ''],
    'াচ্ছিল':['ায়', ''],
    'াচ্ছিস':['ায়', ''],
    'াচ্ছি':['ায়', ''],
    #---------------#
    'িচ্ছেন':['েয়', ''],
    'িচ্ছে':['েয়', ''],
    'িচ্ছ':['েয়', ''],
    'িচ্ছিলাম':['েয়', ''],
    'িচ্ছিলা':['েয়', ''],
    'িচ্ছিলেন':['েয়', ''],
    'িচ্ছিলে':['েয়', ''],
    'িচ্ছিল':['েয়', ''],
    'িচ্ছিস':['েয়', ''],
    'িচ্ছি':['েয়', ''],
    #---------------#
    'েয়েছে':['ায়', ''],
    'িয়েছে':['িয়', ''],
    'য়েছে':['য়', ''],
    'ে.েছে':['া.', ''],
    'েছে':['েছ', ''],
    'ছে':['ছ', ''],
    #---------------#
    'েয়েছ':['ায়', ''],
    'িয়েছ':['িয়', ''],
    'য়েছ':['য়', ''],
    'ে.েছ':['া.', ''],
    'েছ':['েছ', ''],
    'ছ':['ছ', ''],
    #----------------#
    'েয়েছেন':['ায়', ''],
    'িয়েছেন':['িয়', ''],
    'য়েছেন':['য়', ''],
    'ে.েছেন':['া.', ''],
    'েছেন':['েছ', ''],
    'ছেন':['ছ', ''],
    #-----------------#
    'েয়েছিল':['ায়', ''],
    'িয়েছিল':['িয়', ''],
    'য়েছিল':['য়', ''],
    'ে.েছিল':['া.', ''],
    'েছিল':['েছ', ''],
    'ছিল':['ছ', ''],
    #----------------#
    'েয়েছিলা':['ায়', ''],
    'িয়েছিলা':['িয়', ''],
    'য়েছিলা':['য়', ''],
    'ে.েছিলা':['া.', ''],
    'েছিলা':['েছ', ''],
    'ছিলা':['ছ', ''],
    #------------------#
    'েয়েছিলাম':['ায়', ''],
    'িয়েছিলাম':['িয়', ''],
    'য়েছিলাম':['য়', ''],
    'ে.েছিলাম':['া.', ''],
    'েছিলাম':['েছ', ''],
    'ছিলাম':['ছ', ''],
    #------------------#
    'েয়েছিলেন':['ায়', ''],
    'িয়েছিলেন':['িয়', ''],
    'য়েছিলেন':['য়', ''],
    'ে.েছিলেন':['া.', ''],
    'েছিলেন':['েছ', ''],
    'ছিলেন':['ছ', ''],
    #------------------#
    'েয়েছিলে':['ায়', ''],
    'িয়েছিলে':['িয়', ''],
    'য়েছিলে':['য়', ''],
    'ে.েছিলে':['া.', ''],
    'েছিলে':['েছ', ''],
    'ছিলে':['ছ', ''],
    #-----------------#
    'েয়েছিলি':['ায়', ''],
    'িয়েছিলি':['িয়', ''],
    'য়েছিলি':['য়', ''],
    'ে.েছিলি':['া.', ''],
    'েছিলি':['েছ', ''],
    'ছিলি':['ছ', ''],
    #--------------#
    'েয়েছিস':['ায়', ''],
    'িয়েছিস':['িয়', ''],
    'য়েছিস':['য়', ''],
    'ইছিস':['য়', ''],
    'ে.েছিস':['া.', ''],
    'ছিস':['ছ', ''],
    'িস':['িস', ''],
    #-----------------#
    'িয়ে':['িয়ে', 'া'],        # পালিয়ে দমিয়ে
    'েয়ে':['ায়', ''],         # গেয়ে পেয়ে
    'ইয়ে':['য়', ''],          # পাইয়ে, যাইয়ে
    'ায়ে':['া', ''],          # নায়ে পায়ে গায়ে
    'য়ে':['য়', 'য়']           # হয়ে, লয়ে
}

#------------- Rules for special inflection ---------------#
sp_initial_dict = {
    'ই':['ই', ''],
    'ও':['ও', ''],
    'তো':['ত', ''],
    'কে':['ক', ''],
    'তে':['ত', ''],
    'রা':['র', '']
}

sp_final_dict = {
    'টির':['টি', ''],
    'টার':['টা', ''],
    #--------------#
    'লেন':['ল', ''],
    'লাম':['ল', ''],
    'দের':['দের', ''],
    'বেন':['ব', ''],
    #---------------#
    # 'েল':''
    # 'েলো':'েল', #খেলো  মেলো
    # 'ওয়া':
    #---------------#
    'েশে':['েশ', 'েশ'],        # দেশে কেশে
    'ে.ে':['া.', 'ে.'],         # হেসে নেচে গেয়ে
    'া.া.ার':['া.া', ''],   # নামাবার, জানালার
    'া.ার':['া.া', ''],   # কামার, জানার
    'ের':['ের', ''],        # শের
    'ার':['ার', ''],        #কার মার যার
    'েন':['েন', ''],
    #---------------#
    'লি':['লি', ''],
    'টি':['টি', ''],
    'টা':['টা', ''],
    'ছি':['ছি', ''],
    #---------------#
    'রছ':['র', 'র'],
    'ড়ছ':['ড়', 'ড়'],
    'রব':['র', 'র'],
    'ড়ব':['ড়', 'ড়']
}
